# 7. Common library for shared code

Date: 2021-11-21

## Status

Accepted

## Context

The numerous services that make up the Tapas app all have common, non-domain specific, functionality that can be shared via a common library, or be replicated in each service.

## Decision

We will use a common code library for shared code which does not change frequently, but if it would be changed, would need to be changed everywhere.

This improves maintainability as you only have to change the code in one place. This does not only save time, but also reduces the likelihood of forgetting to replace it in one service which could introduce bugs.

## Consequences

Changes in the common code will most likely require multiple services to be redeployed. However, those services would most likely have to have been changed individually and redeployed anyways.

Another consequence is that versioning becomes more complicated.
