# 13. Use Hypermedia APIs when possible

Date: 2021-10-18

## Status

Accepted

## Context

When Executors need to communicate with external devices they can either hard code the API requests or it can discover them at run time via Semantic Hypermedia.

## Decision

We will discover the requests at run-time via the Semantic Hypermedia APIs.

This will decouples the Executors that offer physical services from the Web-enabled devices they use. This will make these Executors more resilient to change in the devices they use and therefore less likely to experience problems over time as the device APIs change.

## Consequences

The implementation of the run-time discovery is more complex, at least until the team has gained more experience in this domain.
