package ch.unisg.executorbase.controller;

import java.util.concurrent.CompletableFuture;
import java.util.logging.Logger;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import ch.unisg.executorbase.services.TaskAvailableService;

@RestController
public class TaskAvailableController {

    @Autowired
    private TaskAvailableService taskAvailableService;

    Logger logger = Logger.getLogger(TaskAvailableController.class.getName());

    /**
    *   Controller for notification about new events.
    *   @return 200 OK
    **/
    @GetMapping(path = "/newtask/{taskType}")
    public ResponseEntity<String> retrieveTaskFromTaskList(@PathVariable("taskType") String taskType) {

        logger.info("ExecutorBase | New " + taskType + " task available");

        CompletableFuture.runAsync(() -> taskAvailableService.newTaskAvailable(taskType.toUpperCase()));

        // Add the content type as a response header
        HttpHeaders responseHeaders = new HttpHeaders();

        return new ResponseEntity<>("OK", responseHeaders, HttpStatus.OK);
    }
}
