package ch.unisg.executorbase.services;

import java.util.logging.Logger;

import org.springframework.beans.factory.annotation.Autowired;

import ch.unisg.executorbase.Executor;
import ch.unisg.executorbase.Task;

public abstract class ExecuteTaskServiceBase implements ExecuteTaskServiceInterface {

    private final Logger logger = Logger.getLogger(ExecuteTaskServiceBase.class.getName());

    @Autowired
    private Executor executor;

    @Autowired
    private GetAssignmentService getAssignmentService;

    @Autowired
    private ExecutionFinishedService executionFinishedService;

    /**
    *   Start the execution of a task
    *   @return void
    **/
    public void executeTask(Task task) {

        logger.info("ExecutorBase | Starting execution");
        executor.setExecuting();

        task.setOutputData(execution(task.getInputData()));

        // TODO implement logic if execution was not successful
        executionFinishedService.publishExecutionFinishedEvent(task.getTaskID(), task.getOutputData(), "SUCCESS");

        logger.info("ExecutorBase | Finish execution");
        getAssignmentService.getAssignment();

    }

}
