package ch.unisg.executorbase.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import ch.unisg.executorbase.Executor;
import ch.unisg.executorbase.ExecutorStatus;
import lombok.RequiredArgsConstructor;

import javax.transaction.Transactional;

@RequiredArgsConstructor
@Component
@Transactional
public class TaskAvailableService {

    @Autowired
    Executor executor;

    @Autowired
    GetAssignmentService getAssignmentService;

    public void newTaskAvailable(String taskType) {
        if (executor.getExecutorStatus() == ExecutorStatus.IDLING && executor.getExecutorType().equalsIgnoreCase(taskType)) {
            getAssignmentService.getAssignment();
        }
    }
}
