package ch.unisg.executorcomputation;

import java.util.logging.Logger;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Component;

import ch.unisg.executorbase.services.ExecuteTaskServiceBase;

@Component
@Primary
public class ExecuteTaskService extends ExecuteTaskServiceBase {

    Logger executorLogger = Logger.getLogger(ExecuteTaskService.class.getName());

    @Override
    public String execution(String input) {
        executorLogger.info("Executor | Starting execution with inputData: " + input);

        ScriptEngineManager mgr = new ScriptEngineManager();
        ScriptEngine engine = mgr.getEngineByName("JavaScript");

        String result = "";
        try {
            result = engine.eval(input).toString();
        } catch (ScriptException e1) {
            // TODO some logic if execution fails
            executorLogger.severe(e1.getMessage());
            return result;
        }

        executorLogger.info("Executor | Finish execution");
        return result;
    }

}
