package ch.unisg.executorcomputation;

import java.util.logging.Logger;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.ComponentScan;

import ch.unisg.executorbase.ExecutorBase;
import ch.unisg.executorbase.services.NotifyExecutorPoolService;

@SpringBootApplication
@ComponentScan({"ch.unisg.executorbase", "ch.unisg.executorcomputation"})
public class ExecutorcomputationApplication extends ExecutorBase {

    static Logger logger = Logger.getLogger(ExecutorcomputationApplication.class.getName());

	public static void main(String[] args) {
        /**
         * This is not a nice solution but I didn't get the @PreDestroy hook to work... This is the
         * only solution which was working so I had to make the executorStopped function static
         * for now.
        */
        Thread printingHook = new Thread(() -> NotifyExecutorPoolService.executorStopped("http://executor-computation:8085"));
        Runtime.getRuntime().addShutdownHook(printingHook);

		SpringApplication.run(ExecutorcomputationApplication.class, args);
	}

}
